## GVolume GVolume — Volume management |

## Functions

char * | g_volume_get_name ()
char * | g_volume_get_uuid ()
GIcon * | g_volume_get_icon ()
GIcon * | g_volume_get_symbolic_icon ()
GDrive * | g_volume_get_drive ()
GMount * | g_volume_get_mount ()
gboolean | g_volume_can_mount ()
gboolean | g_volume_should_automount ()
GFile * | g_volume_get_activation_root ()
void | g_volume_mount ()
gboolean | g_volume_mount_finish ()
gboolean | g_volume_can_eject ()
void | g_volume_eject ()
gboolean | g_volume_eject_finish ()
void | g_volume_eject_with_operation ()
gboolean | g_volume_eject_with_operation_finish ()
char ** | g_volume_enumerate_identifiers ()
char * | g_volume_get_identifier ()
const gchar * | g_volume_get_sort_key ()

## Signals

void | changed | Run Last
void | removed | Run Last

## Types and Values

| GVolume
struct | GVolumeIface
#define | G_VOLUME_IDENTIFIER_KIND_HAL_UDI
#define | G_VOLUME_IDENTIFIER_KIND_LABEL
#define | G_VOLUME_IDENTIFIER_KIND_NFS_MOUNT
#define | G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE
#define | G_VOLUME_IDENTIFIER_KIND_UUID
#define | G_VOLUME_IDENTIFIER_KIND_CLASS

## Object Hierarchy

        GInterface
        ╰── GVolume

## Prerequisites

GVolume requires GObject.

## Includes

    #include <gio/gio.h>

## Description

The GVolume interface represents user-visible objects that can be mounted. Note, when porting from GnomeVFS, GVolume is the moral equivalent of GnomeVFSDrive.

Mounting a GVolume instance is an asynchronous operation. For more information about asynchronous operations, see GAsyncResult and GTask. To mount a GVolume, first call `g_volume_mount()` with (at least) the GVolume instance, optionally a GMountOperation object and a GAsyncReadyCallback.

Typically, one will only want to pass `NULL` for the GMountOperation if automounting all volumes when a desktop session starts since it's not desirable to put up a lot of dialogs asking for credentials.

The callback will be fired when the operation has resolved (either with success or failure), and a GAsyncResult instance will be passed to the callback. That callback should then call `g_volume_mount_finish()` with the GVolume instance and the GAsyncResult data to see if the operation was completed successfully. If an `error` is present when `g_volume_mount_finish()` is called, then it will be filled with any error information.

#### Volume Identifiers

It is sometimes necessary to directly access the underlying operating system object behind a volume (e.g. for passing a volume to an application via the commandline). For this purpose, GIO allows to obtain an 'identifier' for the volume. There can be different kinds of identifiers, such as Hal UDIs, filesystem labels, traditional Unix devices (e.g. `/dev/sda2`), UUIDs. GIO uses predefined strings as names for the different kinds of identifiers: G_VOLUME_IDENTIFIER_KIND_UUID, G_VOLUME_IDENTIFIER_KIND_LABEL, etc. Use `g_volume_get_identifier()` to obtain an identifier for a volume.

Note that G_VOLUME_IDENTIFIER_KIND_HAL_UDI will only be available when the gvfs hal volume monitor is in use. Other volume monitors will generally be able to provide the G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE identifier, which can be used to obtain a hal device by means of `libhal_manager_find_device_string_match()`.

## Functions

### g_volume_get_name ()

    char *
    g_volume_get_name (GVolume *volume);

Gets the name of `volume` .

#### Parameters

volume | a GVolume |

#### Returns

the name for the given `volume` . The returned string should be freed with `g_free()` when no longer needed.

### g_volume_get_uuid ()

    char *
    g_volume_get_uuid (GVolume *volume);

Gets the UUID for the `volume` . The reference is typically based on the file system UUID for the volume in question and should be considered an opaque string. Returns `NULL` if there is no UUID available.

#### Parameters

volume | a GVolume |

#### Returns

the UUID for `volume` or `NULL` if no UUID can be computed. The returned string should be freed with `g_free()` when no longer needed.

[nullable][transfer full]

### g_volume_get_icon ()

    GIcon *
    g_volume_get_icon (GVolume *volume);

Gets the icon for `volume` .

#### Parameters

volume | a GVolume |

#### Returns

a GIcon. The returned object should be unreffed with `g_object_unref()` when no longer needed.

[transfer full]

### g_volume_get_symbolic_icon ()

    GIcon *
    g_volume_get_symbolic_icon (GVolume *volume);

Gets the symbolic icon for `volume` .

#### Parameters

volume | a GVolume |

#### Returns

a GIcon. The returned object should be unreffed with `g_object_unref()` when no longer needed.

[transfer full]

Since: 2.34

### g_volume_get_drive ()

    GDrive *
    g_volume_get_drive (GVolume *volume);

Gets the drive for the `volume` .

#### Parameters

volume | a GVolume |

#### Returns

a GDrive or `NULL` if `volume` is not associated with a drive. The returned object should be unreffed with `g_object_unref()` when no longer needed.

[transfer full][nullable]

### g_volume_get_mount ()

    GMount *
    g_volume_get_mount (GVolume *volume);

Gets the mount for the `volume` .

#### Parameters

volume | a GVolume |

#### Returns

a GMount or `NULL` if `volume` isn't mounted. The returned object should be unreffed with `g_object_unref()` when no longer needed.

[transfer full][nullable]

### g_volume_can_mount ()

    gboolean
    g_volume_can_mount (GVolume *volume);

Checks if a volume can be mounted.

#### Parameters

volume | a GVolume |

#### Returns

`TRUE` if the `volume` can be mounted. `FALSE` otherwise

### g_volume_should_automount ()

    gboolean
    g_volume_should_automount (GVolume *volume);

Returns whether the volume should be automatically mounted.

#### Parameters

volume | a GVolume |

#### Returns

`TRUE` if the volume should be automatically mounted

### g_volume_get_activation_root ()

    GFile *
    g_volume_get_activation_root (GVolume *volume);

Gets the activation root for a GVolume if it is known ahead of mount time. Returns `NULL` otherwise. If not `NULL` and if `volume` is mounted, then the result of `g_mount_get_root()` on the GMount object obtained from `g_volume_get_mount()` will always either be equal or a prefix of what this function returns. In other words, in code

    1
    2
    3
    4
    5
    6
    7
    GMount *mount;
    GFile *mount_root
    GFile *volume_activation_root;

    mount = g_volume_get_mount (volume); // mounted, so never NULL
    mount_root = g_mount_get_root (mount);
    volume_activation_root = g_volume_get_activation_root (volume); // assume not NULL

then the expression

    1
    2
    (g_file_has_prefix (volume_activation_root, mount_root) ||
     g_file_equal (volume_activation_root, mount_root))

will always be `TRUE`.

Activation roots are typically used in GVolumeMonitor implementations to find the underlying mount to shadow, see `g_mount_is_shadowed()` for more details.

#### Parameters

volume | a GVolume |

#### Returns

the activation root of `volume` or `NULL`. Use `g_object_unref()` to free.

[nullable][transfer full]

Since: 2.18

### g_volume_mount ()

    void
    g_volume_mount (GVolume *volume,
                    GMountMountFlags flags,
                    GMountOperation *mount_operation,
                    GCancellable *cancellable,
                    GAsyncReadyCallback callback,
                    gpointer user_data);

Mounts a volume. This is an asynchronous operation, and is finished by calling `g_volume_mount_finish()` with the `volume` and GAsyncResult returned in the `callback` .

Virtual: mount_fn

#### Parameters

volume | a GVolume |
flags | flags affecting the operation |
mount_operation | a GMountOperation or `NULL` to avoid user interaction. | [nullable]
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | a GAsyncReadyCallback, or `NULL`. | [nullable]
user_data | user data that gets passed to `callback` |

### g_volume_mount_finish ()

    gboolean
    g_volume_mount_finish (GVolume *volume,
                           GAsyncResult *result,
                           GError **error);

Finishes mounting a volume. If any errors occurred during the operation, `error` will be set to contain the errors and `FALSE` will be returned.

If the mount operation succeeded, `g_volume_get_mount()` on `volume` is guaranteed to return the mount right after calling this function; there's no need to listen for the 'mount-added' signal on GVolumeMonitor.

#### Parameters

volume | a GVolume |
result | a GAsyncResult |
error | a GError location to store an error, or `NULL` to ignore |

#### Returns

`TRUE`, `FALSE` if operation failed

### g_volume_can_eject ()

    gboolean
    g_volume_can_eject (GVolume *volume);

Checks if a volume can be ejected.

#### Parameters

volume | a GVolume |

#### Returns

`TRUE` if the `volume` can be ejected. `FALSE` otherwise

### g_volume_eject ()

    void
    g_volume_eject (GVolume *volume,
                    GMountUnmountFlags flags,
                    GCancellable *cancellable,
                    GAsyncReadyCallback callback,
                    gpointer user_data);

`g_volume_eject` has been deprecated since version 2.22 and should not be used in newly-written code.

Use `g_volume_eject_with_operation()` instead.

Ejects a volume. This is an asynchronous operation, and is finished by calling `g_volume_eject_finish()` with the `volume` and GAsyncResult returned in the `callback` .

#### Parameters

volume | a GVolume |
flags | flags affecting the unmount if required for eject |
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | a GAsyncReadyCallback, or `NULL`. | [nullable]
user_data | user data that gets passed to `callback` |

### g_volume_eject_finish ()

    gboolean
    g_volume_eject_finish (GVolume *volume,
                           GAsyncResult *result,
                           GError **error);

`g_volume_eject_finish` has been deprecated since version 2.22 and should not be used in newly-written code.

Use `g_volume_eject_with_operation_finish()` instead.

Finishes ejecting a volume. If any errors occurred during the operation, `error` will be set to contain the errors and `FALSE` will be returned.

#### Parameters

volume | pointer to a GVolume |
result | a GAsyncResult |
error | a GError location to store an error, or `NULL` to ignore |

#### Returns

`TRUE`, `FALSE` if operation failed

### g_volume_eject_with_operation ()

    void
    g_volume_eject_with_operation (GVolume *volume,
                                   GMountUnmountFlags flags,
                                   GMountOperation *mount_operation,
                                   GCancellable *cancellable,
                                   GAsyncReadyCallback callback,
                                   gpointer user_data);

Ejects a volume. This is an asynchronous operation, and is finished by calling `g_volume_eject_with_operation_finish()` with the `volume` and GAsyncResult data returned in the `callback` .

#### Parameters

volume | a GVolume |
flags | flags affecting the unmount if required for eject |
mount_operation | a GMountOperation or `NULL` to avoid user interaction. | [nullable]
cancellable | optional GCancellable object, `NULL` to ignore. | [nullable]
callback | a GAsyncReadyCallback, or `NULL`. | [nullable]
user_data | user data passed to `callback` |

Since: 2.22

### g_volume_eject_with_operation_finish ()

    gboolean
    g_volume_eject_with_operation_finish (GVolume *volume,
                                          GAsyncResult *result,
                                          GError **error);

Finishes ejecting a volume. If any errors occurred during the operation, `error` will be set to contain the errors and `FALSE` will be returned.

#### Parameters

volume | a GVolume |
result | a GAsyncResult |
error | a GError location to store the error occurring, or `NULL` |

#### Returns

`TRUE` if the volume was successfully ejected. `FALSE` otherwise

Since: 2.22

### g_volume_enumerate_identifiers ()

    char **
    g_volume_enumerate_identifiers (GVolume *volume);

Gets the kinds of identifiers that `volume` has. Use `g_volume_get_identifier()` to obtain the identifiers themselves.

#### Parameters

volume | a GVolume |

#### Returns

a `NULL`-terminated array of strings containing kinds of identifiers. Use `g_strfreev()` to free.

[array zero-terminated=1][transfer full]

### g_volume_get_identifier ()

    char *
    g_volume_get_identifier (GVolume *volume,
                             const char *kind);

Gets the identifier of the given kind for `volume` . See the introduction for more information about volume identifiers.

#### Parameters

volume | a GVolume |
kind | the kind of identifier to return |

#### Returns

a newly allocated string containing the requested identifier, or `NULL` if the GVolume doesn't have this kind of identifier.

[nullable][transfer full]

### g_volume_get_sort_key ()

    const gchar *
    g_volume_get_sort_key (GVolume *volume);

Gets the sort key for `volume` , if any.

#### Parameters

volume | a GVolume |

#### Returns

Sorting key for `volume` or `NULL` if no such key is available.

[nullable]

Since: 2.32

## Types and Values

### GVolume

    typedef struct _GVolume GVolume;

Opaque mountable volume object.

### struct GVolumeIface

    struct GVolumeIface {
      GTypeInterface g_iface;

      /* signals */

      void        (* changed)               (GVolume             *volume);
      void        (* removed)               (GVolume             *volume);

      /* Virtual Table */

      char      * (* get_name)              (GVolume             *volume);
      GIcon     * (* get_icon)              (GVolume             *volume);
      char      * (* get_uuid)              (GVolume             *volume);
      GDrive    * (* get_drive)             (GVolume             *volume);
      GMount    * (* get_mount)             (GVolume             *volume);
      gboolean    (* can_mount)             (GVolume             *volume);
      gboolean    (* can_eject)             (GVolume             *volume);
      void        (* mount_fn)              (GVolume             *volume,
                                             GMountMountFlags     flags,
                                             GMountOperation     *mount_operation,
                                             GCancellable        *cancellable,
                                             GAsyncReadyCallback  callback,
                                             gpointer             user_data);
      gboolean    (* mount_finish)          (GVolume             *volume,
                                             GAsyncResult        *result,
                                             GError             **error);
      void        (* eject)                 (GVolume             *volume,
                                             GMountUnmountFlags   flags,
                                             GCancellable        *cancellable,
                                             GAsyncReadyCallback  callback,
                                             gpointer             user_data);
      gboolean    (* eject_finish)          (GVolume             *volume,
                                             GAsyncResult        *result,
                                             GError             **error);

      char      * (* get_identifier)        (GVolume             *volume,
                                             const char          *kind);
      char     ** (* enumerate_identifiers) (GVolume             *volume);

      gboolean    (* should_automount)      (GVolume             *volume);

      GFile     * (* get_activation_root)   (GVolume             *volume);

      void        (* eject_with_operation)      (GVolume             *volume,
                                                 GMountUnmountFlags   flags,
                                                 GMountOperation     *mount_operation,
                                                 GCancellable        *cancellable,
                                                 GAsyncReadyCallback  callback,
                                                 gpointer             user_data);
      gboolean    (* eject_with_operation_finish) (GVolume           *volume,
                                                 GAsyncResult        *result,
                                                 GError             **error);

      const gchar * (* get_sort_key)        (GVolume             *volume);
      GIcon       * (* get_symbolic_icon)   (GVolume             *volume);
    };

Interface for implementing operations for mountable volumes.

#### Members

`changed` () | Changed signal that is emitted when the volume's state has changed. |
`removed` () | The removed signal that is emitted when the GVolume have been removed. If the recipient is holding references to the object they should release them so the object can be finalized. |
`get_name` () | Gets a string containing the name of the GVolume. |
`get_icon` () | Gets a GIcon for the GVolume. |
`get_uuid` () | Gets the UUID for the GVolume. The reference is typically based on the file system UUID for the mount in question and should be considered an opaque string. Returns `NULL` if there is no UUID available. |
`get_drive` () | Gets a GDrive the volume is located on. Returns `NULL` if the GVolume is not associated with a GDrive. |
`get_mount` () | Gets a GMount representing the mounted volume. Returns `NULL` if the GVolume is not mounted. |
`can_mount` () | Returns `TRUE` if the GVolume can be mounted. |
`can_eject` () | Checks if a GVolume can be ejected. |
`mount_fn` () | Mounts a given GVolume. GVolume implementations must emit the “aborted” signal before completing a mount operation that is aborted while awaiting input from the user through a GMountOperation instance. |
`mount_finish` () | Finishes a mount operation. |
`eject` () | Ejects a given GVolume. |
`eject_finish` () | Finishes an eject operation. |
`get_identifier` () | Returns the identifier of the given kind, or `NULL` if the GVolume doesn't have one. |
`enumerate_identifiers` () | Returns an array strings listing the kinds of identifiers which the GVolume has. |
`should_automount` () | Returns `TRUE` if the GVolume should be automatically mounted. |
`get_activation_root` () | Returns the activation root for the GVolume if it is known in advance or `NULL` if it is not known. |
`eject_with_operation` () | Starts ejecting a GVolume using a GMountOperation. Since 2.22. |
`eject_with_operation_finish` () | Finishes an eject operation using a GMountOperation. Since 2.22. |
`get_sort_key` () | Gets a key used for sorting GVolume instance or `NULL` if no such key exists. Since 2.32. |
`get_symbolic_icon` () | Gets a symbolic GIcon for the GVolume. Since 2.34. |

### G_VOLUME_IDENTIFIER_KIND_HAL_UDI

    #define G_VOLUME_IDENTIFIER_KIND_HAL_UDI "hal-udi" GLIB_DEPRECATED_MACRO_IN_2_58

`G_VOLUME_IDENTIFIER_KIND_HAL_UDI` has been deprecated since version 2.58 and should not be used in newly-written code.

Do not use, HAL is deprecated.

The string used to obtain a Hal UDI with `g_volume_get_identifier()`.

### G_VOLUME_IDENTIFIER_KIND_LABEL

    #define G_VOLUME_IDENTIFIER_KIND_LABEL "label"

The string used to obtain a filesystem label with `g_volume_get_identifier()`.

### G_VOLUME_IDENTIFIER_KIND_NFS_MOUNT

    #define G_VOLUME_IDENTIFIER_KIND_NFS_MOUNT "nfs-mount"

The string used to obtain a NFS mount with `g_volume_get_identifier()`.

### G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE

    #define G_VOLUME_IDENTIFIER_KIND_UNIX_DEVICE "unix-device"

The string used to obtain a Unix device path with `g_volume_get_identifier()`.

### G_VOLUME_IDENTIFIER_KIND_UUID

    #define G_VOLUME_IDENTIFIER_KIND_UUID "uuid"

The string used to obtain a UUID with `g_volume_get_identifier()`.

### G_VOLUME_IDENTIFIER_KIND_CLASS

    #define G_VOLUME_IDENTIFIER_KIND_CLASS "class"

The string used to obtain the volume class with `g_volume_get_identifier()`.

Known volume classes include `device`, `network`, and `loop`. Other classes may be added in the future.

This is intended to be used by applications to classify GVolume instances into different sections - for example a file manager or file chooser can use this information to show `network` volumes under a "Network" heading and `device` volumes under a "Devices" heading.

## Signal Details

### The `“changed”` signal

    void
    user_function (GVolume *gvolume,
                   gpointer user_data)

Emitted when the volume has been changed.

#### Parameters

user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“removed”` signal

    void
    user_function (GVolume *gvolume,
                   gpointer user_data)

This signal is emitted when the GVolume have been removed. If the recipient is holding references to the object they should release them so the object can be finalized.

#### Parameters

user_data | user data set when the signal handler was connected. |

Flags: Run Last